• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1#!/bin/bash
2#
3#  findmisopt
4#
5#      This is a quick and dirty hack to potentially find a misoptimization
6#      problem. Mostly its to work around problems in bugpoint that prevent
7#      it from finding a problem unless the set of failing optimizations are
8#      known and given to it on the command line.
9#
10#      Given a bitcode file that produces correct output (or return code),
11#      this script will run through all the optimizations passes that gccas
12#      uses (in the same order) and will narrow down which optimizations
13#      cause the program either generate different output or return a
14#      different result code. When the passes have been narrowed down,
15#      bugpoint is invoked to further refine the problem to its origin. If a
16#      release version of bugpoint is available it will be used, otherwise
17#      debug.
18#
19#   Usage:
20#      findmisopt bcfile outdir progargs [match]
21#
22#   Where:
23#      bcfile
24#          is the bitcode file input (the unoptimized working case)
25#      outdir
26#          is a directory into which intermediate results are placed
27#      progargs
28#          is a single argument containing all the arguments the program needs
29#      proginput
30#          is a file name from which stdin should be directed
31#      match
32#          if specified to any value causes the result code of the program to
33#          be used to determine success/fail. If not specified success/fail is
34#          determined by diffing the program's output with the non-optimized
35#          output.
36#
37if [ "$#" -lt 3 ] ; then
38  echo "usage: findmisopt bcfile outdir progargs [match]"
39  exit 1
40fi
41
42dir="${0%%/utils/findmisopt}"
43if [ -x "$dir/Release/bin/bugpoint" ] ; then
44  bugpoint="$dir/Release/bin/bugpoint"
45elif [ -x "$dir/Debug/bin/bugpoint" ] ; then
46  bugpoint="$dir/Debug/bin/bugpoint"
47else
48  echo "findmisopt: bugpoint not found"
49  exit 1
50fi
51
52bcfile="$1"
53outdir="$2"
54args="$3"
55input="$4"
56if [ ! -f "$input" ] ; then
57  input="/dev/null"
58fi
59match="$5"
60name=`basename $bcfile .bc`
61ll="$outdir/${name}.ll"
62s="$outdir/${name}.s"
63prog="$outdir/${name}"
64out="$outdir/${name}.out"
65optbc="$outdir/${name}.opt.bc"
66optll="$outdir/${name}.opt.ll"
67opts="$outdir/${name}.opt.s"
68optprog="$outdir/${name}.opt"
69optout="$outdir/${name}.opt.out"
70ldflags="-lstdc++ -lm -ldl -lc"
71
72echo "Test Name: $name"
73echo "Unoptimized program: $prog"
74echo "  Optimized program: $optprog"
75
76# Define the list of optimizations to run. This comprises the same set of
77# optimizations that opt -std-compile-opts and gccld run, in the same order.
78opt_switches=`llvm-as < /dev/null -o - | opt -std-compile-opts -disable-output -debug-pass=Arguments 2>&1 | sed 's/Pass Arguments: //'`
79ld_switches=`llvm-as < /dev/null -o - | llvm-ld - -debug-pass=Arguments 2>&1 | sed 's/Pass Arguments: //'`
80all_switches="$opt_switches $ld_switches"
81echo "Passes : $all_switches"
82
83# Create output directory if it doesn't exist
84if [ -f "$outdir" ] ; then
85  echo "$outdir is not a directory"
86  exit 1
87fi
88
89if [ ! -d "$outdir" ] ; then
90  mkdir "$outdir" || exit 1
91fi
92
93# Generate the disassembly
94llvm-dis "$bcfile" -o "$ll" -f || exit 1
95
96# Generate the non-optimized program and its output
97llc "$bcfile" -o "$s" -f || exit 1
98gcc "$s" -o "$prog" $ldflags || exit 1
99"$prog" $args > "$out" 2>&1 <$input
100ex1=$?
101
102# Current set of switches is empty
103function tryit {
104  switches_to_use="$1"
105  opt $switches_to_use "$bcfile" -o "$optbc" -f || exit
106  llvm-dis "$optbc" -o "$optll" -f || exit
107  llc "$optbc" -o "$opts" -f || exit
108  gcc "$opts" -o "$optprog" $ldflags || exit
109  "$optprog" $args > "$optout" 2>&1 <"$input"
110  ex2=$?
111
112  if [ -n "$match" ] ; then
113    if [ "$ex1" -ne "$ex2" ] ; then
114      echo "Return code not the same with these switches:"
115      echo $switches
116      echo "Unoptimized returned: $ex1"
117      echo "Optimized   returned: $ex2"
118      return 0
119    fi
120  else
121    diff "$out" "$optout" > /dev/null
122    if [ $? -ne 0 ] ; then
123      echo "Diff fails with these switches:"
124      echo $switches
125      echo "Differences:"
126      diff "$out" "$optout" | head
127      return 0;
128    fi
129  fi
130  return 1
131}
132
133echo "Trying to find optimization that breaks program:"
134for sw in $all_switches ; do
135  echo -n " $sw"
136  switches="$switches $sw"
137  if tryit "$switches" ; then
138    break;
139  fi
140done
141
142# Terminate the previous output with a newline
143echo ""
144
145# Determine if we're done because none of the optimizations broke the program
146if [ "$switches" == " $all_switches" ] ; then
147  echo "The program did not miscompile"
148  exit 0
149fi
150
151final=""
152while [ ! -z "$switches" ] ; do
153  trimmed=`echo "$switches" | sed -e 's/^ *\(-[^ ]*\).*/\1/'`
154  switches=`echo "$switches" | sed -e 's/^ *-[^ ]* *//'`
155  echo "Trimmed $trimmed from left"
156  tryit "$final $switches"
157  if [ "$?" -eq "0" ] ; then
158    echo "Still Failing .. continuing ..."
159    continue
160  else
161    echo "Found required early pass: $trimmed"
162    final="$final $trimmed"
163    continue
164  fi
165  echo "Next Loop"
166done
167
168if [ "$final" == " $all_switches" ] ; then
169  echo "findmisopt: All optimizations pass. Perhaps this isn't a misopt?"
170  exit 0
171fi
172echo "Smallest Optimization list=$final"
173
174bpcmd="$bugpoint -run-llc -disable-loop-extraction --output "$out" --input /dev/null $bcfile $final --args $args"
175
176echo "Running: $bpcmd"
177$bpcmd
178echo "findmisopt finished."
179